﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.DesktopEdition;

namespace BufferTesting
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            ManagedProj4Projection proj = new ManagedProj4Projection();
            proj.ExternalProjectionParametersString = ManagedProj4Projection.GetSphericalMercatorParametersString();
            proj.InternalProjectionParametersString = ManagedProj4Projection.GetSphericalMercatorParametersString();

            winformsMap1.MapUnit = GeographyUnit.Meter;

            PointShape pt = new PointShape(0, 0);

            MultipolygonShape pt1 = pt.Buffer(2000, 3, BufferCapType.Butt, GeographyUnit.Meter, DistanceUnit.Meter);    // Creates null object
            MultipolygonShape pt2 = pt.Buffer(2000, 4, BufferCapType.Round, GeographyUnit.Meter, DistanceUnit.Meter);
            MultipolygonShape pt3 = pt.Buffer(2000, 3, BufferCapType.Square, GeographyUnit.Meter, DistanceUnit.Meter);

            LineShape ln = new LineShape();
            ln.Vertices.Add(new Vertex(-1500, 5000));
            ln.Vertices.Add(new Vertex(1500, 5000));

            MultipolygonShape ln1 = ln.Buffer(1000, 3, BufferCapType.Butt, GeographyUnit.Meter, DistanceUnit.Meter);
            MultipolygonShape ln2 = ln.Buffer(1000, 3, BufferCapType.Round, GeographyUnit.Meter, DistanceUnit.Meter);
            MultipolygonShape ln3 = ln.Buffer(1000, 3, BufferCapType.Square, GeographyUnit.Meter, DistanceUnit.Meter);

            PolygonShape pg = new PolygonShape();
            pg.OuterRing.Vertices.Add(new Vertex(-1500, 8000));
            pg.OuterRing.Vertices.Add(new Vertex(-1500, 9000));
            pg.OuterRing.Vertices.Add(new Vertex(1500, 9000));
            pg.OuterRing.Vertices.Add(new Vertex(1500, 8000));
            pg.OuterRing.Vertices.Add(new Vertex(-1500, 8000));

            MultipolygonShape pg1 = pg.Buffer(1000, 3, BufferCapType.Butt, GeographyUnit.Meter, DistanceUnit.Meter);
            MultipolygonShape pg2 = pg.Buffer(1000, 3, BufferCapType.Round, GeographyUnit.Meter, DistanceUnit.Meter);
            MultipolygonShape pg3 = pg.Buffer(1000, 3, BufferCapType.Square, GeographyUnit.Meter, DistanceUnit.Meter);  // This isn't squared!

            InMemoryFeatureLayer imfl = new InMemoryFeatureLayer();
            imfl.Name = "Buffer";
            imfl.FeatureSource.Projection = proj;
            proj.Open();

            imfl.InternalFeatures.Add(new Feature(pt));
            //imfl.InternalFeatures.Add(new Feature(pt1));    // Creates null object
            imfl.InternalFeatures.Add(new Feature(pt2));
            imfl.InternalFeatures.Add(new Feature(pt3));

            imfl.InternalFeatures.Add(new Feature(ln));
            imfl.InternalFeatures.Add(new Feature(ln1));
            imfl.InternalFeatures.Add(new Feature(ln2));
            imfl.InternalFeatures.Add(new Feature(ln3));

            imfl.InternalFeatures.Add(new Feature(pg));
            imfl.InternalFeatures.Add(new Feature(pg1));
            imfl.InternalFeatures.Add(new Feature(pg2));
            imfl.InternalFeatures.Add(new Feature(pg3));    // This isn't squared!

            imfl.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = new AreaStyle(new GeoPen(GeoColor.StandardColors.Purple), 
                new GeoSolidBrush(GeoColor.FromArgb(75, GeoColor.StandardColors.Purple)));
            imfl.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.StandardColors.Purple));
            imfl.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = new PointStyle(PointSymbolType.Circle, 
                new GeoSolidBrush(GeoColor.StandardColors.Purple), 3);

            imfl.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;


            LayerOverlay lo = new LayerOverlay();
            lo.Name = "Buffer";
            lo.Layers.Add("Buffers", imfl);
            winformsMap1.Overlays.Add(lo);

            imfl.Open();
            RectangleShape rect = imfl.GetBoundingBox();
            rect.ScaleUp(50);
            imfl.Close();

            winformsMap1.CurrentExtent = rect;
            winformsMap1.Refresh();
        }
    }
}
